<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>cnp.queue &#8212; numpy 0.0.post1.dev4+gdc3df0d documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=fa44fd50" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=233b9934" />
    <script src="../../_static/documentation_options.js?v=a3874995"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for cnp.queue</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">click</span>
<span class="kn">from</span> <span class="nn">.common</span> <span class="kn">import</span> <span class="n">processor</span>


<div class="viewcode-block" id="push">
<a class="viewcode-back" href="../../api/cnp.html#cnp.queue.push">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;--pass&quot;</span><span class="p">,</span> <span class="s2">&quot;pass_&quot;</span><span class="p">,</span>
    <span class="n">is_flag</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
    <span class="n">default</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Pass objects back into the stream after storing a copy.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">pass_obj</span>
<span class="k">def</span> <span class="nf">push</span><span class="p">(</span><span class="n">storage</span><span class="p">,</span> <span class="n">arrays</span><span class="p">,</span> <span class="n">pass_</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Push the objects from the queue into a stack-like memory construct.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">queue</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">arrays</span><span class="p">]</span>
    <span class="n">storage</span><span class="o">.</span><span class="n">stack</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">queue</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">pass_</span><span class="p">:</span>
        <span class="k">yield from</span> <span class="p">[</span><span class="n">queue</span><span class="p">]</span></div>



<div class="viewcode-block" id="pop">
<a class="viewcode-back" href="../../api/cnp.html#cnp.queue.pop">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;-i&quot;</span><span class="p">,</span> <span class="s2">&quot;--index&quot;</span><span class="p">,</span>
    <span class="nb">type</span><span class="o">=</span><span class="nb">int</span><span class="p">,</span>
    <span class="n">default</span><span class="o">=-</span><span class="mi">1</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Index to pop. Default: -1.&quot;</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;--append/--prepend&quot;</span><span class="p">,</span>
    <span class="n">default</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Whether to add the objects from the stack before (prepend) or after (append, default) the current queue.&quot;</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;--zip&quot;</span><span class="p">,</span> <span class="s2">&quot;zip_&quot;</span><span class="p">,</span>
    <span class="n">is_flag</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Zip objects popped from stack (s) and those from the queue (q); i.e., [(s1, q1), (s2, q2), ...]. The order is set by the &#39;--append&#39; flag.&quot;</span><span class="p">)</span>
<span class="nd">@processor</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">pass_obj</span>
<span class="k">def</span> <span class="nf">pop</span><span class="p">(</span><span class="n">storage</span><span class="p">,</span> <span class="n">arrays</span><span class="p">,</span> <span class="n">index</span><span class="p">,</span> <span class="n">append</span><span class="p">,</span> <span class="n">zip_</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Pop objects from the stack and add them to the queue.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">stack</span> <span class="o">=</span> <span class="n">storage</span><span class="o">.</span><span class="n">stack</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="n">index</span><span class="p">)</span>
    <span class="n">first</span><span class="p">,</span> <span class="n">second</span> <span class="o">=</span> <span class="p">(</span><span class="n">arrays</span><span class="p">,</span> <span class="n">stack</span><span class="p">)</span> <span class="k">if</span> <span class="n">append</span> <span class="k">else</span> <span class="p">(</span><span class="n">stack</span><span class="p">,</span> <span class="n">arrays</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">zip_</span><span class="p">:</span>
        <span class="k">yield from</span> <span class="nb">zip</span><span class="p">(</span><span class="n">first</span><span class="p">,</span> <span class="n">second</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">yield from</span> <span class="n">first</span>
        <span class="k">yield from</span> <span class="n">second</span></div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">numpy</a></h1>








<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../readme.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../cnp.html">Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../contributing.html">Contributions &amp; Help</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../license.html">License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../authors.html">Authors</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../changelog.html">Changelog</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Contextualize.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>